/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"

#include <webpage.h> 

//
// In dieser Datei wird der GET-request bearbeitet
//
//############################################################################
//
unsigned char searchParameter(unsigned char * param, unsigned char * buffer, 
			unsigned char bufferlen, unsigned char datum) 
//############################################################################
{ 
	unsigned int len = strlen(param); 
	unsigned int i; 
	unsigned char * j;
	for(i=0;i<bufferlen-len-1;i++) // Anfang des Parameters suchen
	{ 
		if(memcmp(buffer+i,param,len)==0 		// wenn der Parameter gefunden wurde
		  && buffer[i+len]=='=' 	// und am Ende ein =
		  && (buffer[i-1]=='?'		// und davor ein ?
		  ||buffer[i-1]=='&'		//   oder ein &
		  ||buffer[i-1]==0))		//   oder eine 0 stehen, dann ...
		{ 
			i = i+len+1; 			// Anfang des Parameterwertes = Anfangparametername + Lnge + 1
			j = buffer+i;			// j zeigt auf das erste Zeichen des Parameterwertes
			while(*j != 0 && *j != '&' && *j != ' ')  j++; //Ende des Parameterwertes suchen
			*j=0;					// 0 hinter den Parameterwert schreiben und String abschlieen
			datum = atoi(buffer+i);
			//printf("***** Parameter %s gefunden, ***** Wert = %d\n",param,datum);
			return(datum);
	 	} 
	}	//printf("Parameter %s not found\n",param);
	return(datum); 	
}

//############################################################################
//
void httpd (char* buffer,int *bufferlen)
//############################################################################
{	
 unsigned int tcpdata;
//Errechnet Startpunkt der Daten im Tcp buffer
//IP Headerlnge + TCP Headerlnge + Ethernetframe
 tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	//Verwaltung Stackpointer

	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack (buffer,bufferlen,&a)==1)
		{
		return;//keine Daten fr Anwendung
		}

	tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
	
	//berprft HTTP Header 
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1)
		{
			
		// Get-Daten auswerten 	
		// Pointerold auf Fehlerseite setzen
		pointerold = Page0;
	
		//File_Name entspricht 8.3 & Endmakierung
		unsigned char File_Name[13];
		
		//berprft Header nach "GET /File_Name HTTP....."
		if ( memcmp(&buffer[tcpdata],"GET /",5) == 0) 
			{
			char *tmppointer = &buffer[tcpdata + 5];
			unsigned char counter = 0;
			//Der Header wird durchsucht beginnend bei GET /
			//bis zum nchsten Space Zeichen
			while ((* tmppointer != 0x20) & (* tmppointer != '?'))
				{
				File_Name[counter] = *tmppointer++;
				counter++;
				}
				//Endmakierung setzen
				File_Name[counter] = '\0';
			
			//Enthlt der Header keinen File Namen ist dieser Index.htm
			if (File_Name[0] == '\0') 
				{
				memcpy(File_Name,"index.htm\0",10);
				}
				
			printf(File_Name);
			printf("\n");
			
			#if USE_MMC
				//Durchsucht Root Verzeichnis nach File Namen
				unsigned char Dir_Attrib;

				//Lade Cluster fr das File welches in File_Name steht 
				tcp_socket->Cluster = 0; //suche im Root Directory
				if (Search_File(File_Name,&tcp_socket->Cluster, &tcp_socket->File_Size,
											 &Dir_Attrib, &buffer[tcpdata]) == 1)
					tcp_socket->File_Block_Counter = 0;
				else
					tcp_socket->Cluster = 0;
					//wurde das File nicht gefunden, wird eine Seite aus Flashspeicher angezeigt
			#endif //USE_MMC
			}	
		if (memcmp(File_Name,"index.htm",9) == 0){pointerold = Page1;}			
					
		// Abfragen der im Prozessor vorhandenen Dateien
		if (memcmp(File_Name,"server.jpg",10) == 0){pointerold = Page2;} //Pointerold auf server.jpg
		
		// Abfragen, ob Parameter zurckgegeben wurden
		hh =searchParameter("VAh",buffer+tcpdata,*bufferlen-tcpdata,hh); 
		mm =searchParameter("VAm",buffer+tcpdata,*bufferlen-tcpdata,mm); 
		ss =searchParameter("VAs",buffer+tcpdata,*bufferlen-tcpdata,ss); 
		VA2=searchParameter("VA2",buffer+tcpdata,*bufferlen-tcpdata,VA2); 
		VA3=searchParameter("VA3",buffer+tcpdata,*bufferlen-tcpdata,VA3); 
		VA4=searchParameter("VA4",buffer+tcpdata,*bufferlen-tcpdata,VA4); 
			//printf("****** hh = %d, mm = %d, ss = %d\n",hh,mm,ss);
		if (VA2) LED_LINES |= (1<<LED_PIN); // LED einschalten
		    else LED_LINES &= (0<<LED_PIN); // LED ausschalten
		if (VA3) LED_LINES_1 |= (1<<LED_PIN_1); // LED einschalten
		    else LED_LINES_1 &= (0<<LED_PIN_1); // LED ausschalten
		if (VA4) LED_LINES_2 |= (1<<LED_PIN_2); // LED einschalten
		    else LED_LINES_2 &= (0<<LED_PIN_2); // LED ausschalten
		
		tcp_store(buffer);								//Speichert Sequenzcounter und Aknowledgecounter
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;	//Setzen des Ack Flags und PSH Flags	
		tcp_add_data (HTTP_OK1,buffer,bufferlen);		//erzeugt HTTP OK Packet
		tcp_make(buffer);								//Erzeugt ein TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);		//Sendet das erzeugte TCP Packet 

		//(Ethernet Frame war voll) weiterer Frame mu gesendet werden!
		tcp_socket->Status = TCP_SOCKET_OPEN2;
		tcp_socket->Pointer = pointerold;
		return;
		}
	
	//Senden der Webseite bzw. Daten war noch nicht Fertig (Ethernet Frame war aber voll)	
	if (tcp_socket->Status == TCP_SOCKET_OPEN2) 
		{
			unsigned char Buffer_Full = 0;
			//Setzen des Ack Flags und PSH Flags	
			buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//erzeugt Seiten Packet
			
			#if USE_MMC
				if(tcp_socket->Cluster != 0)
					{
					Read_File (tcp_socket->Cluster,&buffer[tcpdata],tcp_socket->File_Block_Counter);
					tcp_socket->File_Block_Counter++;
					if (tcp_socket->File_Size > (unsigned long)512)
						{
						Buffer_Full = 1; //es wurden noch nicht alle Daten gesendet
						(unsigned long) tcp_socket->File_Size = (unsigned long) tcp_socket->File_Size - 512;
						TCP_New_Packtlen (buffer,bufferlen,tcpdata + 512);
						}
						else
						{
						Buffer_Full = 0; //es wurden alle Daten gesendet
						TCP_New_Packtlen (buffer,bufferlen,tcpdata + tcp_socket->File_Size);
						}
					goto endmakepacket;
					}
			#endif //USE_MMC
		
			pointerold = tcp_socket->Pointer;
			Buffer_Full = tcp_add_data (pointerold,buffer,bufferlen);
			tcp_socket->Pointer = pointerold;
			
			#if USE_MMC
			endmakepacket:
			#endif //USE_MMC
			
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);	
			if (Buffer_Full == 0)
				{
				#if USE_MMC
				tcp_socket->Cluster = 0;
				#endif //USE_MMC
				tcp_socket->Status = TCP_SOCKET_CLOSE;
				}
			return;		
		}
return;
}


