/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

//#define 				0		//
//#define 				1		// tcpmux 
//#define				3		//  
//#define 				4  		//
//#define 				5 		//rje 
//#define 				7 		//echo 
//#define 				9 		//discard 
//#define 				11 		//systat 
//#define 				13 		//daytime 
//#define 				15 		//netstat 
//#define 				17 		//qotd 
//#define 				18 		//send/rwp 
//#define 				19 		//chargen 
//#define 				20 		//ftp-data

#define SOCKET_FTPD		0x1500 	//ftp 

//#define 				22 		//ssh, pcAnywhere 

#define SOCKET_TELNET 	0x1700 	//Telnet

//#define 				25 		//SMTP 
//#define 				27 		//ETRN 
//#define 				29 		//msg-icp 
//#define 				31 		//msg-auth 
//#define 				33 		//dsp 
//#define 				37 		//time 
//#define 				38 		//RAP 
//#define 				39 		//rlp 
//#define 				40  	//
//#define 				41  	//
//#define 				42 		//nameserv, WINS 
//#define 				43 		//whois, nickname 
//#define 				49 		//TACACS, Login Host Protocol 
//#define 				50 		//RMCP, re-mail-ck 
//#define 				53 		//DNS 
//#define 				57 		//MTP 
//#define 				59 		//NFILE 
//#define 				63 		//whois++ 
//#define 				66 		//sql*net 
//#define 				67 		//bootps 

#define SOCKET_DHCP		0x4400 	//bootpd/dhcp 

//#define 				69 		//Trivial File Transfer Protocol (tftp) 
//#define 				70 		//Gopher 
//#define 				79 		//finger 

#define SOCKET_HTTP		0x5000	//www-http	

//#define 				87  	//
//#define 				88 		//Kerberos, WWW 
//#define 				95 		//supdup 
//#define 				96 		//DIXIE 
//#define				98 		//linuxconf 
//#define 				101 	//HOSTNAME 
//#define 				102 	//ISO, X.400, ITOT 
//#define 				105 	//cso 
//#define 				106 	//poppassd 
//#define 				109 	//POP2 
//#define 				110 	//POP3 
//#define 				111 	//Sun RPC Portmapper 
//#define 				113 	//identd/auth 
//#define 				115 	//sftp 
//#define 				116  	//
//#define 				117 	//uucp 
//#define 				118  	//
//#define 				119 	//NNTP 
//#define 				120 	//CFDP 
//#define 				123 	//NTP Network Time Protocol 
//#define 				124 	//SecureID 
//#define 				129 	//PWDGEN 
//#define 				133 	//statsrv 
//#define 				135 	//loc-srv/epmap 
//#define 				137 	//netbios-ns 
//#define 				138 	//netbios-dgm (UDP) 
//#define 				139 	//NetBIOS 
//#define 				143 	//IMAP 
//#define 				144 	//NewS 
//#define 				150 	// 
//#define 				152 	//BFTP 
//#define 				153 	//SGMP 
//#define 				156 	// 
//#define 				161 	//SNMP 
//#define 				175 	//vmnet 
//#define 				177 	//XDMCP 
//#define 				178 	//NextStep Window Server 
//#define 				179 	//BGP 
//#define 				180 	//SLmail admin 
//#define 				199 	//smux 
//#define 				210 	//Z39.50 
//#define 				213 	// 
//#define 				218 	//MPP 
//#define 				220 	//IMAP3 
//#define 				256 	//	 
//#define 				257 	// 
//#define 				258 	// 
//#define 				259 	//ESRO 
//#define 				264 	//FW1_topo 
//#define 				311 	//Apple WebAdmin 
//#define 				350 	//MATIP type A 
//#define 				351 	//MATIP type B 
//#define 				360 	// 
//#define 				363 	//RSVP tunnel 
//#define 				366 	//ODMR (On-Demand Mail Relay) 
//#define 				371 	// 
//#define 				387 	//AURP (AppleTalk Update-Based Routing Protocol) 
//#define 				389 	//LDAP 
//#define 				407 	//Timbuktu 
//#define 				427 	// 
//#define 				434 	//Mobile IP 
//#define 				443 	//ssl 
//#define 				444 	//snpp, Simple Network Paging Protocol 
//#define 				445 	//SMB 
//#define 				458 	//QuickTime TV/Conferencing 
//#define 				468 	//Photuris 
//#define 				475 	// 
//#define 				500 	//ISAKMP, pluto 
//#define 				511 	// 
//#define 				512 	//biff, rexec 
//#define 				513 	//who, rlogin 
//#define 				514 	//syslog, rsh 
//#define 				515 	//lp, lpr, line printer 
//#define 				517 	//talk 
//#define 				520 	//RIP (Routing Information Protocol) 
//#define 				521 	//RIPng 
//#define 				522 	//ULS 
//#define 				531 	//IRC 
//#define 				543 	//KLogin, AppleShare over IP 
//#define 				545 	//QuickTime 
//#define 				548 	//AFP 
//#define 				554 	//Real Time Streaming Protocol 
//#define 				555 	//phAse Zero 
//#define 				563 	//NNTP over SSL 
//#define 				575 	//VEMMI 
//#define 				581 	//Bundle Discovery Protocol 
//#define 				593 	//MS-RPC 
//#define 				608 	//SIFT/UFT 
//#define 				626 	//Apple ASIA 
//#define 				631 	//IPP (Internet Printing Protocol) 
//#define 				635 	//mountd 
//#define 				636 	//sldap 
//#define 				642 	//EMSD 
//#define 				648 	//RRP (NSI Registry Registrar Protocol) 
//#define 				655 	//tinc 
//#define 				660 	//Apple MacOS Server Admin 
//#define 				666 	//Doom 
//#define 				674 	//ACAP 
//#define 				687 	//AppleShare IP Registry 
//#define 				700 	//buddyphone 
//#define 				705 	//AgentX for SNMP 
//#define 				901 	//swat, realsecure 
//#define 				993 	//s-imap 
//#define 				995 	//s-pop 
//#define 				999 	// 
//#define 				1024	//  
//#define 				1025	//  
//#define 				1050	//  
//#define 				1062	//Veracity 
//#define 				1080	//SOCKS 
//#define 				1085	//WebObjects 
//#define 				1100	//
//#define 				1105	//  
//#define 				1114	//  
//#define 				1227	//DNS2Go 
//#define 				1234	//
//#define 				1243	//SubSeven 
//#define 				1338	//Millennium Worm 
//#define 				1352	//Lotus Notes 
//#define 				1381	//Apple Network License Manager 
//#define 				1417	//Timbuktu 
//#define 				1418	//Timbuktu 
//#define 				1419	//Timbuktu 
//#define 				1420	//
//#define 				1433	//Microsoft SQL Server 
//#define 				1434	//Microsoft SQL Monitor 
//#define 				1477	// 
//#define 				1478	//
//#define 				1490	//
//#define 				1494	//Citrix ICA Protocol 
//#define 				1498	//  
//#define 				1500	//  
//#define 				1503 	//T.120 
//#define 				1521 	//Oracle SQL 
//#define 				1522 	// 
//#define 				1524 	// 
//#define 				1525 	//prospero 
//#define 				1526 	//prospero 
//#define 				1527 	//tlisrv 
//#define 				1529 	// 
//#define 				1547 	// 
//#define 				1604 	//Citrix ICA, MS Terminal Server 
//#define 				1645 	//RADIUS Authentication 
//#define 				1646 	//RADIUS Accounting 
//#define 				1680 	//Carbon Copy 
//#define 				1701 	//L2TP/LSF 
//#define 				1717 	//Convoy 
//#define 				1720 	//H.323/Q.931 
//#define 				1723 	//PPTP control port 
//#define 				1731 	// 
//#define 				1755 	//Windows Media .asf 
//#define 				1758 	//TFTP multicast 
//#define 				1761 	// 
//#define 				1762 	// 
//#define 				1808 	// 
//#define 				1812 	//RADIUS server 
//#define 				1813 	//RADIUS accounting 
//#define 				1818 	//ETFTP 
//#define 				1968 	// 
//#define 				1973 	//DLSw DCAP/DRAP 
//#define 				1975 	// 
//#define 				1978 	// 
//#define 				1979 	// 
//#define 				1985 	//HSRP 
//#define 				1999 	//Cisco AUTH 
//#define 				2000 	// 
//#define 				2001 	//glimpse 
//#define 				2005 	// 
//#define 				2010 	// 
//#define 				2023 	// 
//#define 				2048 	// 
//#define 				2049 	//NFS 
//#define 				2064 	//distributed.net 
//#define 				2065 	//DLSw 
//#define 				2066 	//DLSw 
//#define 				2080 	// 
//#define 				2106 	//MZAP 
//#define 				2140 	//DeepThroat 
//#define 				2301 	//Compaq Insight Management Web Agents 
//#define 				2327 	//Netscape Conference 
//#define 				2336 	//Apple UG Control 
//#define 				2345 	// 
//#define 				2427 	//MGCP gateway 
//#define 				2504 	//WLBS 
//#define 				2535 	//MADCAP 
//#define 				2543 	//sip 
//#define 				2565 	// 
//#define 				2592 	//netrek 
//#define 				2727 	//MGCP call agent 
//#define 				2766 	// 
//#define 				2628 	//DICT 
//#define 				2998 	//ISS Real Secure Console Service Port 
//#define 				3000 	//Firstclass 
//#define 				3001 	// 
//#define 				3031 	//Apple AgentVU 
//#define 				3052 	// 
//#define 				3128 	//squid 
//#define 				3130 	//ICP 
//#define 				3150 	//DeepThroat 
//#define 				3264 	//ccmail 
//#define 				3283 	//Apple NetAssitant 
//#define 				3288 	//COPS 
//#define 				3305 	//ODETTE 
//#define 				3306 	//mySQL 
//#define 				3352 	// 
//#define 				3389 	//RDP Protocol (Terminal Server) 
//#define 				3520 	// 
//#define 				3521 	//netrek 
//#define 				3879 	// 
//#define 				4000 	//icq, command-n-conquer 
//#define 				4045 	// 
//#define 				4144 	// 
//#define 				4242 	// 
//#define 				4321 	//rwhois 
//#define 				4333 	//mSQL 
//#define 				4444 	// 
//#define 				47017	//  
//#define 				4827 	//HTCP 
//#define 				5000 	// 
//#define 				5001 	// 
//#define 				5002 	// 
//#define 				5004 	//RTP 
//#define 				5005 	//RTP 
//#define 				5010 	//Yahoo! Messenger 
//#define 				5050 	// 
//#define 				5060 	//SIP 
//#define 				5135 	// 
//#define 				5150 	// 
//#define 				5190 	//AIM 
//#define 				5222 	// 
//#define 				5353 	// 
//#define 				5400 	// 
//#define 				5500 	//securid 
//#define 				5501 	//securidprop 
//#define 				5300 	// 
//#define 				5423 	//Apple VirtualUser 
//#define 				5555 	// 
//#define 				5556 	// 
//#define 				5631 	//PCAnywhere data 
//#define 				5632 	//PCAnywhere 
//#define 				5678 	// 
//#define 				5800 	//VNC 
//#define 				5801 	//VNC 
//#define 				5900 	//VNC 
//#define 				5901 	//VNC 
//#define 				5843 	// 
//#define 				6000 	//X Windows 
//#define 				6112 	//BattleNet 
//#define 				6050 	// 
//#define 				6499 	// 
//#define 				6500 	// 
//#define 				6502 	//Netscape Conference 
//#define 				6547	//  
//#define 				6548	//  
//#define 				6549	//  
//#define 				6666 	// 
//#define 				6667 	//IRC 
//#define 				6670 	//VocalTec Internet Phone, DeepThroat 
//#define 				6699 	//napster 
//#define 				6776 	//Sub7 
//#define 				6968 	// 
//#define 				6969 	// 
//#define 				6970 	//RTP 
//#define 				6971 	// 
//#define 				7000 	// 
//#define 				7007 	//MSBD, Windows Media encoder 
//#define 				7070 	//RealServer/QuickTime 
//#define 				7161 	// 
//#define 				7323 	// 
//#define 				7777 	// 
//#define 				7778 	//Unreal 
//#define 				7640 	// 
//#define 				7648 	//CU-SeeMe 
//#define 				7649 	//CU-SeeMe 
//#define 				7654 	// 
//#define 				8000 	// 
//#define 				8002 	// 
//#define 				8010 	//WinGate 2.1 
//#define 				8080 	//HTTP 
//#define 				8100 	// 
//#define 				8181 	//HTTP 
//#define 				8383 	//IMail WWW 
//#define 				8765 	// 
//#define 				8875 	//napster 
//#define 				8888 	//napster 
//#define 				8890 	// 
//#define 				9000 	// 
//#define 				9090 	// 
//#define 				9200 	// 
//#define 				9704 	// 
//#define 				9669 	// 
//#define 				9876 	// 
//#define 				9989 	// 
//#define 				10008	//cheese worm 
//#define 				10752	//  
//#define 				12345	//  
//#define 				11371 	//PGP 5 Keyserver 
//#define 				12346 	// 	
//#define 				13000 	// 
//#define 				13223 	//PowWow 
//#define 				13224 	//PowWow 
//#define 				14000 	// 
//#define 				14237 	//Palm 
//#define 				14238 	//Palm 
//#define 				14690 	// 
//#define 				16969 	// 
//#define 				18888 	//LiquidAudio 
//#define 				21157 	//Activision 
//#define 				22555 	// 
//#define 				22703 	// 
//#define 				22793 	// 
//#define 				23213 	//PowWow 
//#define 				23214 	//PowWow 
//#define 				23456 	//EvilFTP 
//#define 				26000 	//Quake 
//#define 				27000 	// 
//#define 				27001 	//QuakeWorld 
//#define 				27010 	//Half-Life 
//#define 				27015 	//Half-Life 
//#define 				27374 	// 
//#define 				27444 	// 
//#define 				27665 	// 
//#define 				27910 	// 
//#define 				27960 	//QuakeIII 
//#define 				28000 	// 
//#define 				28001 	// 
//#define 				28002 	// 
//#define 				28003 	// 
//#define 				28004 	// 
//#define 				28005 	// 
//#define 				28006 	// 
//#define 				28007 	// 
//#define 				28008 	// 
//#define 				30029 	//AOL Admin 
//#define 				30100 	// 
//#define 				30101 	// 
//#define 				30102 	// 
//#define 				30103 	// 
//#define 				30303 	// 
//#define 				30464 	// 
//#define 				31335 	// 
//#define 				31337 	//Back Orifice 
//#define 				32000 	// 
//#define 				32771 	// 
//#define 				32777 	//rpc.walld 
//#define 				34555 	// 
//#define 				40193 	//Novell 
//#define 				41524 	//arcserve discovery 
//#define 				45000 	//Cisco NetRanger postofficed 
//#define 				50505 	// 
//#define 				52901 	// 
//#define 				54321 	// 
//#define 				61000 	// 
//#define 				65301 	// 
//#define 				32773 	//rpc.ttdbserverd 
//#define 				32776 	//rpc.spray 
//#define 				32779 	//rpc.cmsd 
//#define 				38036 	//timestep 
